import os
from zope.interface import implements

from twisted.python import usage
from twisted.plugin import IPlugin
from twisted.application.service import IServiceMaker
from twisted.application import internet, service

from schscripts.daemon import bashplex, guiplex

class Options(usage.Options):
    optParameters = [
        ("clientport", "p", 570, "Client Port"),
        ('pingInterval', 'i', 10),
        ('pingTimeout', 't', 10),
    ]


class SCHServiceMaker(object):
    implements(IServiceMaker, IPlugin)
    tapname = "sch_daemon"
    description = "SCH Daemon"
    options = Options

    def makeService(self, options):
        
        factory = bashplex.DelimitedBashReceiverFactory()
        factory.pingInterval=int(options['pingInterval'])
        factory.pingTimeout=int(options['pingTimeout'])

        clientService = internet.TCPServer(
            int(options['clientport']), 
            factory)

        if not os.path.isdir("/var/run/sch-scripts"):
            os.mkdir("/var/run/sch-scripts", 0700)
        # TODO: fchown to root:admin?

        guiService = internet.UNIXServer(
            "/var/run/sch-scripts/sch-daemon.socket",
            guiplex.GUIFactory())

        topService = service.MultiService()
        topService.addService(clientService)
        topService.addService(guiService)

        return topService


serviceMaker = SCHServiceMaker()
