#!/usr/bin/env python
#-*- coding: utf-8 -*-

import gtk
#import pango
import pygtk
import os
import subprocess
import re

class assistant:
    def __init__(self):
        # Calculate the defaults
        defaults = subprocess.Popen(['scripts/server/sch-ltsp-build-client-gen-helper'], 
                    stdout = subprocess.PIPE).communicate()[0].strip().split()
        defdic = {}
        for item in defaults:
            item = item.split('=')
            if item[1] == 'True' or item[1] == 'False':
                defdic[item[0].strip()] = eval(item[1].strip())
            else:
                defdic[item[0].strip()] = item[1].strip()
        
        
        # Create the assistant
        self.assist = gtk.Assistant()
        self.assist.set_title('Βοηθός δημιουργίας εικονικού δίσκου')
        self.assist.set_icon_from_file('/usr/share/icons/Humanity/categories/48/configuration_section.svg')
        self.assist.set_property('resizable', False)
        self.assist.connect('cancel', self.cancel)
        self.assist.connect('apply', self.apply)
        self.assist.connect('close', self.close)
        self.assist.set_forward_page_func(self.page_func)
        
        
        # Welcome page
        self.continuebox = gtk.RadioButton(None, msg.replace)
        self.exitbox = gtk.RadioButton(self.continuebox, msg.exit)
        vbox = self.VBox([msg.desc, self.continuebox, self.exitbox])
        self.assist.append_page(vbox)
        self.assist.set_page_type(vbox, gtk.ASSISTANT_PAGE_INTRO)
        self.assist.set_page_title(vbox, "Εισαγωγή")
        self.assist.set_page_complete(vbox, True)
        
        
        # thin or fat selection page
        self.thinradio = gtk.RadioButton(None, "Εικονικός δίσκος για thin clients")
        self.fatradio = gtk.RadioButton(self.thinradio, "Εικονικός δίσκος για fat clients")
        if defdic['Type'] == 'thin':
            self.thinradio.set_active(True)
        else:
            self.fatradio.set_active(True)
        
        vbox = self.VBox([msg.type, self.thinradio, self.fatradio])
        self.assist.append_page(vbox)
        self.assist.set_page_title(vbox, "Τύπος σταθμών εργασίας")
        self.assist.set_page_complete(vbox, True)
        
        
        # 1st page to be shown if clients are fat        
        self.gnome = gtk.CheckButton('Ubuntu')
        self.gnome.set_active(defdic['ubuntu-desktop'])
        self.edu = gtk.CheckButton('Edubuntu')
        self.edu.set_active(defdic['edubuntu-desktop'])
        self.kde = gtk.CheckButton('Kubuntu')
        self.kde.set_active(defdic['kubuntu-desktop'])
        self.xfce = gtk.CheckButton('Xubuntu')
        self.xfce.set_active(defdic['xubuntu-desktop'])
        self.lxde = gtk.CheckButton('Lubuntu')
        self.lxde.set_active(defdic['lubuntu-desktop'])
        vbox = self.VBox([msg.envs, self.gnome, self.edu, self.xfce, self.kde, 
                          self.lxde])
        
        self.assist.append_page(vbox)
        self.assist.set_page_title(vbox, "Περιβάλλοντα εργασίας")
        self.assist.set_page_complete(vbox, True)
        
        
        # 2nd page to be shown if clients are fat
        self.model = gtk.ListStore(bool,str, str, str)
        self.model.append([False, 'Κοινή λίστα για όλες τις βαθμίδες', 'gtk-edit', 
        '/etc/sch-scripts/koina.list'])
        self.model.append([False, 'Λίστα προγραμμάτων για το Δημοτικό', 'gtk-edit', 
        '/etc/sch-scripts/dimotiko.list'])
        self.model.append([False, 'Λίστα προγραμμάτων για το Γυμνάσιο', 'gtk-edit', 
        '/etc/sch-scripts/gymnasio.list'])
        self.model.append([False, 'Λίστα προγραμμάτων για το Λύκειο', 'gtk-edit', 
        '/etc/sch-scripts/lykeio.list'])
        
        for item in self.model:
            item[0] = defdic[item[3]]
        
        tree = gtk.TreeView(self.model)
        
        col = gtk.TreeViewColumn()
        editcol = gtk.TreeViewColumn()
        
        tree.connect('row-activated', self.activate, editcol)
        tree.append_column(editcol)
        tree.append_column(col)
        
        celltog = gtk.CellRendererToggle()
        col.pack_start(celltog, False)
        celltog.connect('toggled', self.toggled)
        
        celltxt = gtk.CellRendererText()
        col.pack_start(celltxt)
        
        cellbtn = gtk.CellRendererPixbuf()
        editcol.pack_start(cellbtn, False)

        col.set_attributes(celltog, active=0)
        col.set_attributes(celltxt, text=1)
        editcol.set_attributes(cellbtn, stock_id=2)
        
        vbox = self.VBox([msg.lists, tree])
        self.assist.append_page(vbox)
        self.assist.set_page_title(vbox, "Λίστες προγραμμάτων")
        self.assist.set_page_complete(vbox, True)


        # Last "apply" page
        vbox = self.VBox([msg.apply])
        self.assist.append_page(vbox)
        self.assist.set_page_type(vbox, gtk.ASSISTANT_PAGE_CONFIRM)
        self.assist.set_page_title(vbox, "Εφαρμογή αλλαγών")
        self.assist.set_page_complete(vbox, True)


        # Last "apply" page in case the user didn't select to run the assistant
        vbox = self.VBox([msg.exitlbl])
        self.assist.append_page(vbox)
        self.assist.set_page_type(vbox, gtk.ASSISTANT_PAGE_SUMMARY)
        self.assist.set_page_title(vbox, "Κλείσιμο οδηγού")
        self.assist.set_page_complete(vbox, True)
        
        self.assist.show_all()
        
        if not os.path.isfile('/etc/ltsp/ltsp-build-client.conf'):
            self.exitbox.hide()
            self.continuebox.hide()
            self.continuebox.set_active(True) #Just in case
        
    
    def VBox(self, children):
        vbox = gtk.VBox(spacing=16)
        vbox.set_property('border_width', 15)

        for child in children:
            vbox.pack_start(child, False, True)
        return vbox
        
    
    def toggled(self, widget, row):
        if row != '0': # So koina.list will be always selected
            self.model[row][0] = not self.model[row][0]
    
    def activate(self, widget, path, col, editcol):
        if col is editcol:
            path = self.model[path[0]][3]
            src = os.path.join('/usr/share/doc/sch-scripts/examples/', 
                                                os.path.split(path)[1])
            subprocess.Popen(['scripts/common/sch-install-example',
                                      src, path, str(False), str(True)])


    def close(self, widget):
        """Executes sch-ltsp-build-client with the existing .conf file"""
        subprocess.Popen([ 'x-terminal-emulator', '-e', 'sh', '-c', 'scripts/server/sch-ltsp-build-client'
            + '&& read -p "Sch-ltsp-build-client finished succesfully. Press [Enter] to close this window." dummy'
            + '|| read -p "Sch-ltsp-build-client finished with errors. Press [Enter] to close this window." dummy']
            )
        exit()


    def apply(self, widget):
        examplepath = '../doc/sch-scripts/examples/ltsp-build-client.conf'
        if os.path.isfile(examplepath):
            examplefile = open(examplepath, 'r')
        else:
            import gzip
            examplepath += '.gz'
            examplefile = gzip.open(examplepath, 'r')

        confstring = examplefile.read()
        examplefile.close()

        if not self.thinradio.get_active():
            envs = []
            if self.gnome.get_active():
                envs.append('ubuntu-desktop')
            if self.kde.get_active():
                envs.append('kubuntu-desktop')
            if self.lxde.get_active():
                envs.append('lubuntu-desktop')
            if self.edu.get_active():
                envs.append('edubuntu-desktop')
            if self.xfce.get_active():
                envs.append('xubuntu-desktop')

            confstring = re.sub(
                '''\n#?FAT_CLIENT_DESKTOPS="[^"]*"''',
                '''\nFAT_CLIENT_DESKTOPS="%s"''' % ' '.join(envs),
                confstring)

        lists = []
        for i in self.model:
            if i[0]:
                lists.append(i[3])

        confstring = re.sub(
            '''\n#?PACKAGE_LISTS="[^"]*"''',
            '''\nPACKAGE_LISTS="\n    %s\n"''' % '\n    '.join(lists),
            confstring)
        
        conffile = open('/etc/ltsp/ltsp-build-client.conf', 'w')
        conffile.write(confstring)
        conffile.close()
        self.close(widget)
    
    
    def page_func(self, page):
        if page is 0: 
            if self.continuebox.get_active():
                return 1
            else:
                return 5
        elif page is 1:
            if self.fatradio.get_active():
                self.fat = True
                return 2
            else:
                self.thin = True
                return 4 # Finish
        elif page is 2: return 3
        elif page is 3: return 4
        
    
    def cancel(self, widget=None):
        exit()


class msg:
    def Label(txt):
        hbox = gtk.HBox()
        label = gtk.Label(txt)
        hbox.pack_start(label, False)
        #label.set_property('wrap', True)
        #label.set_property('wrap_mode', pango.WRAP_WORD)
        #label.set_width_chars(100)
        return hbox
    
    desc_msg = '''Αυτός ο βοηθός θα σας καθοδηγήσει κατά τη διαδικασία δημιουργίας
ενός εικονικού δίσκου (chroot) για thin ή fat clients, δημιουργώντας
το αρχείο /etc/ltsp/ltsp-build-client.conf ανάλογα με τις απαντήσεις
σας και εκτελώντας στη συνέχεια την εντολή sch-ltsp-build-client.'''

    if os.path.isfile('/etc/ltsp/ltsp-build-client.conf'):
        desc_msg += '''

Το αρχείο /etc/ltsp/ltsp-build-client.conf υπάρχει ήδη, είτε από
προηγούμενη εκτέλεση του οδηγού είτε επειδή έχει προετοιμαστεί
χειρωνακτικά. Τι θέλετε να κάνει ο οδηγός;'''

    desc = Label(desc_msg)

    replace = '''Να δημιουργήσει ένα νέο αρχείο ρυθμίσεων, αντικαθιστώντας
το παλιό.'''

    exit = '''Να μη γίνει χρήση του οδηγού. Να εκτελεστεί απλά η εντολή
sch-ltsp-build-client χρησιμοποιώντας το υπάρχον αρχείο.'''
    
    type = Label(
'''Επιλέξτε αν θέλετε να δημιουργήσετε έναν εικονικό δίσκο για thin clients,
όπου τα τερματικά χρησιμοποιούν την επεξεργαστική ισχύ του εξυπηρετητή,
ή για fat clients, όπου χρησιμοποιούν τη δική τους επεξεργαστική ισχύ.

Οι thin clients συντηρούνται πιο εύκολα και προτείνονται για παλιά εργαστήρια.

Η δημιουργία και η συντήρηση ενός εικονικού δίσκου για fat clients είναι
πιο χρονοβόρα, αλλά προσφέρει καλύτερες επιδόσεις, εφόσον όμως οι σταθμοί
εργασίας είναι σχετικά καινούργιοι και έχουν τουλάχιστον 512 Mb RAM.

Για μεικτά εργαστήρια με μερικούς καινούργιους και μερικούς παλιούς
υπολογιστές, προτείνεται να δημιουργήσετε εικονικό δίσκο για fat clients.
Τα τερματικά με λιγότερο από 300 Mb RAM θα λειτουργήσουν αυτόματα ως thin.''')

    envs = Label(
'''Επιλέξτε τα περιβάλλοντα εργασίας που θέλετε να εγκατασταθούν στους clients.''')
    
    lists = Label(
'''Σε αυτό το βήμα μπορείτε να επιλέξετε και να επεξεργαστείτε τις λίστες
λογισμικού που θα εγκατασταθούν.
Τα περιβάλλοντα εργασίας edubuntu και ubuntu περιλαμβάνουν ήδη τα πιο
συνηθισμένα προγράμματα, όπως είναι το OpenOffice και ο Firefox, και
επομένως οι παρακάτω λίστες περιέχουν μόνο τα επιπλέον πακέτα.

Πατώντας διπλό κλικ στο εικονίδιο επεξεργασία, θα ανοίξει η αντίστοιχη
λίστα στον επεξεργαστή κειμένου για να κάνετε τις αλλαγές που θέλετε.''')
    
    apply = Label(
'''Πατήστε Εφαρμογή για να δημιουργηθεί το αρχείο /etc/ltsp/ltsp-build-client.conf 
και να εκτελεστεί η εντολή sch-ltsp-build-client για να ξεκινήσει η
δημιουργία του εικονικού δίσκου.''')

    exitlbl = Label(
'''Ο οδηγός δεν έκανε αλλαγές στο αρχείο /etc/ltsp/ltsp-build-client.conf.

Πατήστε Κλείσιμο για να εκτελεστεί η εντολή sch-ltsp-build-client και να ξεκινήσει η
δημιουργία του εικονικού δίσκου.''')
    


if __name__ == '__main__':
    assistant()
    gtk.main()
